//
// Progmain.c
//
#include <windows.h>
#include "resource.h"
#include "hmct110.h"
#include "g9001ctl.h"
#include "g9002ctl.h"
#include "opt_ctl.h"

#define IDD_TMR		10000

#define MAX_BRD		16
#define MAX_MDL		32

LRESULT CALLBACK WndProc( HWND, UINT, WPARAM, LPARAM );
void	init_global( void );		// O[oϐ
void	init_disp( HWND );			// ʏ
void	init_board( void );			// {[h̏
void	inf_disp( HWND );			// ޲\
void	close_board( HWND );		// {[h̏I

void	click_ssta( HWND );			// ђʐMJn݂دꂽ
void	click_csta( HWND );			// دʐMJn݂دꂽ
void	click_cstp( HWND );			// دʐM~݂دꂽ
void	click_msto( HWND, WORD );	// Ͻްޔėpo݂دꂽ
void	click_mdlo( HWND, WORD );	// DIOӼޭٔėpo݂دꂽ

DWORD	read_opt( HWND );			// Ͻް޵߼߰ēǏo
DWORD	read_dio( HWND );			// DIOӼޭُԓǏo
void	ctl_enbl( HWND, BOOL );


HINSTANCE	gInst;					// CX^Xnh
HBITMAP		gGrn, gWht;				// rbg}bvnh
DWORD		hMnt[MAX_BRD];			// foCXnh
DWORD		hDev = 0xffffffff;		// foCXnh
HWND		gWnd;					// EBhEnh

WORD		g_lno = 0;
WORD		g_mid  = 0;
DWORD		gCnt = 0;
HMCT110INFO	gInf[MAX_BRD];

//
// register main window calss
//
BOOL InitApplication( HINSTANCE hInstance )
{
	WNDCLASSEX  wc ;

	if( hInstance )	{
		// EBhENX`
		wc.style		 =	CS_HREDRAW | CS_VREDRAW;			// EBhE̎(TCYύXĕ`)
		wc.lpfnWndProc	 =	(WNDPROC)WndProc;					// EChE֐̃AhX
		wc.cbClsExtra	 =	0;									// ̑̃NX
		wc.cbWndExtra	 =	DLGWINDOWEXTRA;						// ̑̃EBhE
		wc.hInstance	 =	hInstance;							// ̃CX^X̃nh
		wc.hIcon		 =	LoadIcon(NULL, IDI_APPLICATION);	// WACR̃nh
		wc.hCursor		 =	LoadCursor(NULL, IDC_ARROW);		// }EXJ[\̃nh
		wc.hbrBackground =	(HBRUSH)(COLOR_BTNFACE + 1);		// EBhE̔wiF({^̕\ʂ̉e)
		wc.lpszMenuName	 =	NULL;								// Cj[̖O
		wc.lpszClassName =	"MAIN";								// EBhENX̖O
		wc.cbSize		 =	sizeof(WNDCLASSEX);					// WNDCLASSEX\̂̃TCYݒ
		wc.hIconSm		 =	LoadIcon(NULL, IDI_WINLOGO);		// X[ACR		
	}
	return( RegisterClassEx(&wc) ) ;							// WNDCLASS̓o^
}

//
// careate main window
//
HWND InitInstance( HINSTANCE hInstance, int nCmdShow )
{
	HWND hWnd ;

	hWnd = CreateDialog( hInstance, "MAIN", 0, NULL ) ;

	if( hWnd != NULL ) {
		ShowWindow( hWnd, nCmdShow ) ;
		UpdateWindow( hWnd ) ;
	}
	return hWnd ;
}

//
// WinMain
//
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,	LPSTR lpCmdLine, int nCmdShow )
{
	MSG		msg;
	HWND	hWnd;

	init_global();	// initialize global parameter
	init_board();	// initialize HPC104-MCT110M

	// register main window class
	if(!InitApplication(hInstance))					return FALSE;

	// create main window
	if(!(hWnd = InitInstance(hInstance, nCmdShow)))	return FALSE;

	gWnd  = hWnd;
	gInst = hInstance;
	
	// load bitmap
	gWht = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_WHT) );
	gGrn = LoadBitmap( gInst, MAKEINTRESOURCE(IDB_GRN) );
	
	init_disp( hWnd );	// initialize the program display
		
	// dispatch messages
	while(GetMessage(&msg, NULL, 0, 0)) {
		if(!IsDialogMessage( hWnd, &msg )) {
			TranslateMessage( &msg );
			DispatchMessage( &msg );
		}
	}
	return msg.wParam;
}

//
// user menu
//
LRESULT userMenu( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{	
	BOOL	b;
	int		index;
	
	switch( LOWORD( wParam )) {
	case IDD_ADR:	
		if( HIWORD( wParam ) == CBN_SELCHANGE ) {
			index = SendDlgItemMessage( hWnd, IDD_ADR, CB_GETCURSEL, 0, 0 );
			SendDlgItemMessage( hWnd, IDD_ADR, CB_SETCURSEL, index, 0 );
			inf_disp( hWnd );					
		}
												break;
	case IDD_MID:	
		if( HIWORD( wParam ) == CBN_SELCHANGE ) {
			index = SendDlgItemMessage( hWnd, IDD_MID, CB_GETCURSEL, 0, 0 );
			SendDlgItemMessage( hWnd, IDD_MID, CB_SETCURSEL, index, 0 );
			g_mid = GetDlgItemInt( hWnd, IDD_MID, &b, FALSE );	// ӼޭID擾
		}
												break;
	case IDD_SYSTA:	
		click_ssta( hWnd );			break;
	case IDD_CYSTA:	click_csta( hWnd );			break;
	case IDD_CYSTP:	click_cstp( hWnd );			break;
	case IDD_MO1:	click_msto( hWnd, 1 );		break;
	case IDD_MO2:	click_msto( hWnd, 2 );		break;
	case IDD_MO3:	click_msto( hWnd, 4 );		break;
	case IDD_MO4:	click_msto( hWnd, 8 );		break;
	case IDD_LO0:	click_mdlo( hWnd, 1 );		break;
	case IDD_LO1:	click_mdlo( hWnd, 2 );		break;
	case IDD_LO2:	click_mdlo( hWnd, 4 );		break;
	case IDD_LO3:	click_mdlo( hWnd, 8 );		break;
	case IDD_LO4:	click_mdlo( hWnd, 0x10 );	break;
	case IDD_LO5:	click_mdlo( hWnd, 0x20 );	break;
	case IDD_LO6:	click_mdlo( hWnd, 0x40 );	break;
	case IDD_LO7:	click_mdlo( hWnd, 0x80 );	break;
	case IDD_LO8:	click_mdlo( hWnd, 0x100 );	break;
	case IDD_LO9:	click_mdlo( hWnd, 0x200 );	break;
	case IDD_LOA:	click_mdlo( hWnd, 0x400 );	break;
	case IDD_LOB:	click_mdlo( hWnd, 0x800 );	break;
	case IDD_LOC:	click_mdlo( hWnd, 0x1000 );	break;
	case IDD_LOD:	click_mdlo( hWnd, 0x2000 );	break;
	case IDD_LOE:	click_mdlo( hWnd, 0x4000 );	break;
	case IDD_LOF:	click_mdlo( hWnd, 0x8000 );	break;

	default:
		return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

//
// user timer
//
LRESULT userTimer( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	DWORD	dwRet = 0;
	WORD	wMid,
			wPrm,
			wFlg;
	char	szBuf[1024];
	char	szMsg[1024];
	
	switch( wParam ) {
		case IDD_TMR:
			dwRet = read_opt( hWnd );
			if( dwRet != 0 ) {
				ctl_enbl( hWnd, FALSE );
				KillTimer( hWnd, IDD_TMR );
				MessageBox( hWnd, "vIȴװ܂.\nIvV|[gǂ߂܂.", "x", MB_OK );	
			}

			dwRet = read_dio( hWnd );
			if( dwRet != 0 ) {
				ctl_enbl( hWnd, FALSE );
				KillTimer( hWnd, IDD_TMR );
//				if( dwRet & (CYC_COM_ERROR)) {		// دʐMװ
				if( dwRet & (COM_OTHER_ERROR)) {		// دʐMװ
					wsprintf( szMsg, "دʐMװ\n" );
					for( wPrm = 0; wPrm < 4; wPrm++ ) {
						dwRet = mct110_rLclCycErr( hDev, 0, wPrm, &wFlg );	// دʐMװ׸ޓǏo
						dwRet = mct110_wLclCycErr( hDev, 0, wPrm,  wFlg );	// دʐMװ׸ؾ
						for( wMid = 0; wMid < 16; wMid++ ) {
							if( wFlg & (0x0001<<wMid)) {
								wsprintf( szBuf, "ӼޭID:%02x ", wMid+(wPrm*16));
								strcat( szMsg, szBuf );
							}
						}
					}
					strcat( szMsg, "\nدʐM~܂" );
					MessageBox( hWnd, szMsg, "x", MB_OK );
				}
			}
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}


//
// window procedure
//
LRESULT CALLBACK WndProc( HWND hWnd, UINT uMessage, WPARAM wParam, LPARAM lParam )
{
	switch( uMessage ) {
		case WM_CREATE:
			break;
		case WM_COMMAND:
			userMenu( hWnd, uMessage, wParam, lParam ); 
			break;
		case WM_TIMER:
			userTimer( hWnd, uMessage, wParam, lParam ); 
			break;
		case WM_CLOSE:
		case WM_DESTROY:
			close_board( hWnd );
			PostQuitMessage( 0 );
			break;
		default:
			return DefWindowProc( hWnd, uMessage, wParam, lParam );
	}
	return 0 ;
}

// ۰ٕϐ
void init_global( void )
{
	DWORD	i;

	for( i = 0; i < MAX_BRD; i++ ) {
		hMnt[i] = 0xffffffff;
	}
	g_lno = 0;
	g_mid = 0;
}

// ʏ
void init_disp( HWND hWnd )
{
	DWORD	i;
	char	szBuf[255];
	DWORD	dwRet;
	DWORD	h;
	
	ctl_enbl( hWnd, FALSE );
	EnableWindow( GetDlgItem( hWnd, IDD_SYSTA ), FALSE );
	EnableWindow( GetDlgItem( hWnd, IDD_CYSTA ), FALSE );
	EnableWindow( GetDlgItem( hWnd, IDD_CYSTP ), FALSE );

	// SĂMCT110
	for( i = 0; i < gCnt; i++ ) {
		// \
		if(gInf[i].dwAddressSpace)	wsprintf( szBuf, "%s%x", "I/O:", gInf[i].dwBaseAddress );	// I/O
		else						wsprintf( szBuf, "%s%x", "MEM:", gInf[i].dwBaseAddress );	// MEM
		SendDlgItemMessage( hWnd, IDD_ADR, CB_ADDSTRING, 0, (LPARAM)szBuf );
		// MCT110̵
		dwRet = mct110_OpenMstBrd( &h, &gInf[i] );
		if( dwRet ) {
			MessageBox( hWnd, "foCXI[vł܂.", "", MB_OK );
			return;
		} else {
			m_init( h );				// ײ1G9001
			hMnt[i] = h;
		}
	}

	SendDlgItemMessage( hWnd, IDD_ADR, CB_SETCURSEL, 0, 0 );
	SendDlgItemMessage( hWnd, IDD_MID, CB_SETCURSEL, 0, 0 );
	inf_disp( hWnd );
	EnableWindow( GetDlgItem( hWnd, IDD_SYSTA ), TRUE );
	SetTimer( hWnd, IDD_TMR, 110, NULL );
}

// MCT110
void init_board( void )
{
	DWORD	dwRet = 0;

	dwRet = mct110_GetMstBrdCount( &gCnt );
	if( dwRet ) {
		MessageBox( NULL, "{[hFł܂.", "", MB_OK );
		return;
	}
	dwRet = mct110_GetMstBrdInfo( &gCnt, &gInf[0] );
	if( dwRet ) {
		MessageBox( NULL, "foCX񂪎擾ł܂.", "", MB_OK );
	}
}

// ޲\
void  inf_disp( HWND hWnd )
{
	int		nIndex;
	char	szBuf[256];
	char	szSpc[128];
	char	szMod[128];

	nIndex = SendDlgItemMessage( hWnd, IDD_ADR, CB_GETCURSEL, 0, 0 );
	// foCX\
	if( gInf[nIndex].dwAddressSpace )	wsprintf( szSpc, "I/O" );		// I/O
	else								wsprintf( szSpc, "MEM" );		// memory
	if( gInf[nIndex].dwAccessMode )		wsprintf( szMod, "8byte" );		// 8byte
	else								wsprintf( szMod, "512byte" );	// 512byte
	wsprintf( szBuf, "%s\r\n%s%d\r\n%s%08xh\r\n%s%d\r\n%s%d\r\n%s%s\r\n%s%s",
			"*** ޲ ***", 
			"޽ԍ:       ", gInf[nIndex].dwBusNumber,
			"ްڽ:     ", gInf[nIndex].dwBaseAddress,
			"IRQ ԍ:      ", gInf[nIndex].dwIrqNo,
			"Ǘԍ:      ", gInf[nIndex].dwNumber,
			"ڽ:     ", szSpc,
			"gpӰ:  ", szMod );
	SetDlgItemText( hWnd, IDD_INFO, szBuf );
 	hDev = hMnt[nIndex];
}

// I
void close_board( HWND hWnd )
{
	DWORD i;

	for( i = 0; i < MAX_BRD; i++ ) {
		if( hMnt[i] != 0xffffffff ) {
			hDev = hMnt[i];
			mct110_wOptPortB( hDev, 2, 0 );	// ϽްޔėpoOFF
			m_stop_cyc( hDev );				// ײ1دʐM~
			mct110_CloseMstBrd( hDev );		// Ͻް޸۰
			hMnt[i] = 0xffffffff;
		}
	}
}

// ђʐMJn݂دꂽ
void click_ssta( HWND hWnd )			
{
	DWORD	dwRet = 0;
	WORD	wMid, wMcnt, wDcnt;
	BYTE	byData;
	char	szBuf[128];

	SendDlgItemMessage( hWnd, IDD_MID, CB_RESETCONTENT, 0, 0 );

	dwRet = m_strt_sys( hDev );
	if( dwRet ){
		wsprintf( szBuf, "ђʐMװ(װ:%08x)", dwRet );
		MessageBox( hWnd, szBuf, "", MB_OK );
		return;
	}

	// ۰޲Ǐo & ޯɕ\
	wMcnt = 0;
	wDcnt = 0;
	for( wMid = 0; wMid < 64; wMid++ ) { 
		dwRet = mct110_rLclInfo( hDev, 0, wMid, &byData );	
		if( dwRet ){
			wsprintf( szBuf, "۰޲Ǐoװ(װ:%08x)", dwRet );
			MessageBox( hWnd, szBuf, "", MB_OK );
			return;
		}
		if( byData & 0x80 ) {		// gpłӼޭ
			wMcnt++;				// Ӽޭِ
			if( MAX_MDL < wMcnt )	{
				wsprintf( szBuf, "Ӽޭق̐܂." );
				MessageBox( hWnd, szBuf, "", MB_OK );
				return;
			}
			if( byData & 0x8 ) {	// Motion

			} else {				// DIO
				wDcnt++;
				wsprintf( szBuf, "%d", wMid );
				SendDlgItemMessage( hWnd, IDD_MID, CB_ADDSTRING, 0, (LPARAM)szBuf );
			}
		}
	}
	SendDlgItemMessage( hWnd, IDD_MID, CB_SETCURSEL, 0, 0 );
	if( wDcnt == 0 ) {
		wsprintf( szBuf, "DIOӼޭقڑĂ܂" );
		MessageBox( hWnd, szBuf, "", MB_OK );
	} else {
		EnableWindow( GetDlgItem( hWnd, IDD_CYSTA ), TRUE );
	}
}

// دʐMJn݂دꂽ
void click_csta( HWND hWnd )		
{
	DWORD	dwRet = 0;
	BOOL	b;
	char	szBuf[128],
			szMsg[128];
	WORD	wMid,
			wPrm,
			wFlg;

	dwRet = m_strt_cyc( hDev );
	if( dwRet ) {
		wsprintf( szMsg, "دʐMJnװ(װ:%08x),\n", dwRet );
		for( wPrm = 0; wPrm < 4; wPrm++ ) {
			dwRet = mct110_rLclCycErr( hDev, 0, wPrm, &wFlg );	// دʐMװ׸ޓǏo
			dwRet = mct110_wLclCycErr( hDev, 0, wPrm,  wFlg );	// دʐMװ׸ؾ
			for( wMid = 0; wMid < 16; wMid++ ) {
				if( wFlg & (0x0001<<wMid)) {
					wsprintf( szBuf, "ӼޭID:%02x ", wMid+(wPrm*16));
					strcat( szMsg, szBuf );
				}
			}
		}
		MessageBox( hWnd, szMsg, "", MB_OK );
	} else {
		g_mid = GetDlgItemInt( hWnd, IDD_MID, &b, FALSE );	// ӼޭID擾
		EnableWindow( GetDlgItem( hWnd, IDD_ADR ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_CYSTA ), FALSE );
		EnableWindow( GetDlgItem( hWnd, IDD_CYSTP ), TRUE );
		ctl_enbl( hWnd, TRUE );
	}
}

// دʐM~݂دꂽ
void click_cstp( HWND hWnd )		
{
	DWORD	dwRet = 0;
	char	szBuf[128];

	dwRet = m_stop_cyc( hDev );
	if( dwRet ) {
		wsprintf( szBuf, "دʐM~װ(װ:%08x)", dwRet );
		MessageBox( hWnd, szBuf, "", MB_OK );
	} else {
		EnableWindow( GetDlgItem( hWnd, IDD_ADR ), TRUE );
		EnableWindow( GetDlgItem( hWnd, IDD_CYSTA ), TRUE );
		EnableWindow( GetDlgItem( hWnd, IDD_CYSTP ), FALSE );
		ctl_enbl( hWnd, FALSE );
	}
}

// Ͻްޔėpo݂دꂽ
void click_msto( HWND hWnd, WORD wData )	
{
	DWORD	dwRet = 0;
	char	szBuf[128];
	int		nIndex;

	nIndex = SendDlgItemMessage( hWnd, IDD_ADR, CB_GETCURSEL, 0, 0 );
	dwRet = o_wout( hDev, gInf[nIndex], wData );	// DIOӼޭُo
	if( dwRet ) {
		wsprintf( szBuf, "Ͻްޔėpoʹװ(װ:%08x)", dwRet );
		MessageBox( hWnd, szBuf, "", MB_OK );
	}
}

// DIOӼޭُo
void click_mdlo( HWND hWnd, WORD wData )
{
	DWORD	dwRet = 0;
	char	szBuf[128];

	dwRet = d_outp( hDev, g_mid, wData );	// DIOӼޭُo
	if( dwRet ) {
		wsprintf( szBuf, "DIOӼޭُoʹװ(װ:%08x)", dwRet );
		MessageBox( hWnd, szBuf, "", MB_OK );
	}
}

// Ͻް޵߼߰ēǏo
DWORD read_opt( HWND hWnd )
{
	DWORD	dwRet = 0;
	WORD	wData;
	int		nIndex;

	nIndex = SendDlgItemMessage( hWnd, IDD_ADR, CB_GETCURSEL, 0, 0 );
	dwRet |= o_rinp( hDev, gInf[nIndex], &wData );	// ėp̓|[gǏo
	if( wData & 0x01 )	
		SendDlgItemMessage( hWnd, IDC_MI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x02 )	
		SendDlgItemMessage( hWnd, IDC_MI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x04 )	
		SendDlgItemMessage( hWnd, IDC_MI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x08 )	
		SendDlgItemMessage( hWnd, IDC_MI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x10 )	
		SendDlgItemMessage( hWnd, IDC_MI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x20 )	
		SendDlgItemMessage( hWnd, IDC_MI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x40 )	
		SendDlgItemMessage( hWnd, IDC_MI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
	if( wData & 0x80 )	
		SendDlgItemMessage( hWnd, IDC_MI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDC_MI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

	dwRet |= o_rout( hDev, gInf[nIndex], &wData );	// ėpo̓|[gǏo
	if( wData & 1 )	
		SendDlgItemMessage( hWnd, IDD_MO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_MO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wData & 2 )	
		SendDlgItemMessage( hWnd, IDD_MO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_MO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wData & 4 )	
		SendDlgItemMessage( hWnd, IDD_MO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_MO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	if( wData & 8 )	
		SendDlgItemMessage( hWnd, IDD_MO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
	else				
		SendDlgItemMessage( hWnd, IDD_MO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	return dwRet;
}

// DIOӼޭٓǏo
DWORD read_dio( HWND hWnd )
{
	DWORD	dwRet = 0;
	WORD	wData,
			wSts;

	dwRet = mct110_rCenMsts( hDev, 0, &wSts );
	if( dwRet )			return dwRet;
	if( wSts & 0x0008 ) {	// دʐMװ
		dwRet  = mct110_wCenCmd( hDev, 0, 0x3100 );	// دʐM~
		dwRet |= (CYC_COM_ERROR);
		if( dwRet )		return dwRet;
	}
	if( wSts & 0x1000 ) {	// دʐM
		dwRet |= mct110_rIoPortW( hDev, 0, g_mid, 0, &wData );	// G9002͓Ǐo
		if( wData & 1 )	
			SendDlgItemMessage( hWnd, IDC_LI0, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI0, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 2 )	
			SendDlgItemMessage( hWnd, IDC_LI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 4 )	
			SendDlgItemMessage( hWnd, IDC_LI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 8 )	
			SendDlgItemMessage( hWnd, IDC_LI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x10 )	
			SendDlgItemMessage( hWnd, IDC_LI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x20 )	
			SendDlgItemMessage( hWnd, IDC_LI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x40 )	
			SendDlgItemMessage( hWnd, IDC_LI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x80 )	
			SendDlgItemMessage( hWnd, IDC_LI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x100 )	
			SendDlgItemMessage( hWnd, IDC_LI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x200 )	
			SendDlgItemMessage( hWnd, IDC_LI9, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LI9, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x400 )	
			SendDlgItemMessage( hWnd, IDC_LIA, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LIA, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x800 )	
			SendDlgItemMessage( hWnd, IDC_LIB, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LIB, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x1000 )	
			SendDlgItemMessage( hWnd, IDC_LIC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LIC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x2000 )	
			SendDlgItemMessage( hWnd, IDC_LID, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LID, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x4000 )	
			SendDlgItemMessage( hWnd, IDC_LIE, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LIE, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );
		if( wData & 0x8000 )	
			SendDlgItemMessage( hWnd, IDC_LIF, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDC_LIF, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gWht );

		dwRet |= mct110_rIoPortW( hDev, 0, g_mid, 2, &wData );	// G9002o͓Ǐo
		if( wData & 1 )	
			SendDlgItemMessage( hWnd, IDD_LO0, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO0, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 2 )	
			SendDlgItemMessage( hWnd, IDD_LO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 4 )	
			SendDlgItemMessage( hWnd, IDD_LO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 8 )	
			SendDlgItemMessage( hWnd, IDD_LO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x10 )	
			SendDlgItemMessage( hWnd, IDD_LO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x20 )	
			SendDlgItemMessage( hWnd, IDD_LO5, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO5, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x40 )	
			SendDlgItemMessage( hWnd, IDD_LO6, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO6, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x80 )	
			SendDlgItemMessage( hWnd, IDD_LO7, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO7, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x100 )	
			SendDlgItemMessage( hWnd, IDD_LO8, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO8, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x200 )	
			SendDlgItemMessage( hWnd, IDD_LO9, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LO9, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x400 )	
			SendDlgItemMessage( hWnd, IDD_LOA, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LOA, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x800 )	
			SendDlgItemMessage( hWnd, IDD_LOB, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LOB, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x1000 )	
			SendDlgItemMessage( hWnd, IDD_LOC, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LOC, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x2000 )	
			SendDlgItemMessage( hWnd, IDD_LOD, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LOD, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x4000 )	
			SendDlgItemMessage( hWnd, IDD_LOE, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LOE, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		if( wData & 0x8000 )	
			SendDlgItemMessage( hWnd, IDD_LOF, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)gGrn );
		else				
			SendDlgItemMessage( hWnd, IDD_LOF, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	} else {		
		ctl_enbl( hWnd, FALSE );
	}
	return dwRet;
}

// Rg[gp^s؂ւ
void ctl_enbl( HWND hWnd, BOOL bFlag )
{
	EnableWindow( GetDlgItem( hWnd, IDD_LO0 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO1 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO2 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO3 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO4 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO5 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO6 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO7 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO8 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LO9 ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LOA ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LOB ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LOC ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LOD ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LOE ), bFlag );
	EnableWindow( GetDlgItem( hWnd, IDD_LOF ), bFlag );
	if( bFlag == FALSE ) {
		SendDlgItemMessage( hWnd, IDD_LO0, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO1, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO2, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO3, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO4, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO5, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO6, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO7, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO8, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LO9, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LOA, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LOB, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LOC, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LOD, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LOE, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDD_LOF, BM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI0, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI1, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI2, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI3, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI4, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI5, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI6, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI7, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI8, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LI9, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LIA, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LIB, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LIC, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LID, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LIE, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
		SendDlgItemMessage( hWnd, IDC_LIF, STM_SETIMAGE, (WPARAM)IMAGE_BITMAP, (LPARAM)NULL );
	}
}



